#!/bin/sh 

update_ProductInfo()
{
	# removes the node from the ProductInfo and PatchInfo objects
	# related to the application.
	echo "Updating Product and Patch objects" | tee -a $LOG_FILE
	#PROD="$1"
   PROD="$1#$IRONAME"
	NODE="$2"
	PROD_IO=`wlookup -r ProductInfo "$PROD"`
	PATCH_IOS=`idlcall $PROD_IO _get_patches`
	NUM=`idlarg 1 $PATCH_IOS`
	NUM=`expr "$NUM" + 2 `
	COUNT=2
	while [ "$COUNT" -lt "$NUM" ]
	do
		PATCH_IO=`idlarg $COUNT $PATCH_IOS`
#            PATCH_LB=`idlcall $PATCH_IO _get_label` 
#            wregister -u -r PatchInfo "$PATCH_LB"   
		idlcall $PATCH_IO remove_host_locations '{ 1' $NODE '}'
		COUNT=`expr "$COUNT" + 1 `
	done
	idlcall $PROD_IO remove_host_locations '{ 1' $NODE '}'

      # If this is the last Node where the RC Controller was installed then we
	# should also unregister the ProductInfo and PatchInfo
      HOST_LOCS=`idlcall $PROD_IO _get_locations`
      NUM=`idlarg 1 $HOST_LOCS`
      if [ $NUM -eq 0 ]; then  
        remove_ProductInfo "RC_TGT_M"
      fi

#      wregister -u -r ProductInfo "$PROD"  

}
	
remove_ProductInfo()
{
   # Remove the product and patch installation objects
	echo "Removing Product and Patch objects" | tee -a $LOG_FILE
	#PROD="$1"
   PROD="$1#$IRONAME"
	PROD_IO=`wlookup -r ProductInfo "$PROD"`
	PATCH_IOS=`idlcall $PROD_IO _get_patches`
	NUM=`idlarg 1 $PATCH_IOS`
	NUM=`expr "$NUM" + 2 `
	COUNT=2
	while [ "$COUNT" -lt "$NUM" ]
	do
		PATCH_IO=`idlarg $COUNT $PATCH_IOS`
            PATCH_LB=`idlcall $PATCH_IO _get_label`
            PATCH_LB=`eval echo $PATCH_LB`
            IR_PATCH_LB = "$PATCH_LB#$IRONAME" 
            wregister -u -r PatchInfo "$IR_PATCH_LB"
		idlcall $PATCH_IO TMF_SysAdmin::PolicyDrivenBase::remove
		COUNT=`expr "$COUNT" + 1 `
	done
      wregister -u -r ProductInfo "$PROD"
	idlcall $PROD_IO TMF_SysAdmin::PolicyDrivenBase::remove
}
 
remove_misc()
{
   $RM $DBDIR/.installed/RC_TGT_M.CFG

   set +e
   (cd $RC_TGT_DIR/UNINST; ./REGINI ./REGILOG.INI)
   (cd $RC_TGT_DIR; ./VERSION /U)
   set -e

   if [ ! -f $DBDIR/.installed/RC_CTL_M.CFG ] ; then
      set +e
      $WIN_DIR/system32/NET stop TME10RC
      $RC_TGT_DIR/INSTSRV TME10RC wipe &> $LOG_FILE
      $RM $WIN_DIR/RCSERV.EXE
      set -e

      if [ ! -f $BINDIR/.installed/RC_ALI_BIN ] ; then
         $RM $BINDIR/TME/PCREMOTE/pctarget.exe  
      fi
 
      $RM $RC_TGT_DIR
   else
      RC_CTL_DIR=`cat $DBDIR/.installed/RC_CTL_M.CFG | tr '\\\' '/'`

      if [ $RC_TGT_DIR = $RC_CTL_DIR ]; then
	      $RM $RC_TGT_DIR/EQNRCMAI.EXE
         $RM $RC_TGT_DIR/EQNRCDKY.DLL
	      $RM $RC_TGT_DIR/EQNRCDMO.DLL
         set +e
         $RM $RC_TGT_DIR/EQNRCGVD.DLL
	      $RM $RC_TGT_DIR/EQNRCG40.DLL
	      $RM $RC_TGT_DIR/EQNRCG35.DLL
         set -e
         $RM $RC_TGT_DIR/FLT32.DLL
         $RM $RC_TGT_DIR/pctinst.bat
         $RM $RC_TGT_DIR/LOCALE/EQNRCENU.HLP	
         $RM $RC_TGT_DIR/LOCALE/EQNRCFRA.HLP	
         $RM $RC_TGT_DIR/LOCALE/EQNRCJPN.HLP	
         $RM $RC_TGT_DIR/LOCALE/EQNRCPTB.HLP	
         $RM $RC_TGT_DIR/LOCALE/EQNKBENU.DAT
         $RM $RC_TGT_DIR/LOCALE/EQNKBFRA.DAT
         $RM $RC_TGT_DIR/LOCALE/EQNKBPTB.DAT
         $RM $RC_TGT_DIR/LOCALE/EQNKBJPN.DAT
         $RM $RC_TGT_DIR/LOCALE/EQNRCPTB.DLL	
         $RM $RC_TGT_DIR/LOCALE/EQNRCJPN.DLL	
         $RM $RC_TGT_DIR/LOCALE/EQNRCFRA.DLL
         $RM $RC_TGT_DIR/SYS
         $RM $RC_TGT_DIR/UNINST
      else
         $RM $RC_TGT_DIR
      fi
   fi

   set +e
   $MV $WIN_DIR/EQNHOOK.DLL $WIN_DIR/EQNHOOK.RMV   
   $MV $WIN_DIR/system32/VDD.DLL $WIN_DIR/system32/VDD.RMV
   $MV $WIN_DIR/system32/VDDFIFO.DLL $WIN_DIR/system32/VDDFIFO.RMV
   $MV $WIN_DIR/system32/VDDHOOK.DLL $WIN_DIR/system32/VDDHOOK.RMV
   $MV $WIN_DIR/system32/drivers/KEYEX.SYS $WIN_DIR/system32/drivers/KEYEX.RMV
   $MV $WIN_DIR/system32/drivers/MOUEX.SYS $WIN_DIR/system32/drivers/MOUEX.RMV
   $MV $WIN_DIR/system32/drivers/TGRAB.SYS $WIN_DIR/system32/drivers/TGRAB.RMV
   set -e
}

remove_TagFiles()
{
   # remove TAG files to allow re-install 
	$RM $DBDIR/.installed/RC_TGT_M_ALIDB
	$RM $DBDIR/.installed/RC_TGT_M_DB
	$RM $EXECDIR/$INTERP/.installed/RC_TGT_M_BIN

	$RM $DBDIR/.installed/pa_3.6_RTM_*
	$RM $DBDIR/.installed/pa_3.6_RTM_*
	$RM $EXECDIR/$INTERP/.installed/pa_3.6_RTM_*
}

remove_bin()
{
   echo "Removing Binaries" | tee -a $LOG_FILE
   cd $BINDIR
	$RM DCAFTGT*
}

remove_files()
{
	remove_bin
}

#######################################
# main starts here
#######################################
#set -o xtrace

BO=`objcall 0.0.0 self`
if [ -z "$BO" ];then
   echo "You must source in the Tivoli environment and set the"
   echo "logins for the appropriate ManagedNodes administrator"
   echo "to run this command."
   exit 1
fi
OSERV=`objcall $BO getattr oserv`
EXECDIR=`objcall $OSERV query install_dir`
TOP=`dirname $EXECDIR`
DBDIR=`objcall $OSERV query db_dir`
INTERP=`objcall $OSERV query interp`
BINDIR=$EXECDIR/$INTERP
DISP=`echo $OSERV |awk -F. '{print $2}'`
CLO=`wlookup Library`
TNR=`wlookup NameRegistry`
LocalHostOid=`objcall 0.0.0 getattr HostLocation`
NodeNameQ=`idlcall $LocalHostOid SysAdmin::PolicyDrivenBase::_get_label `
NodeName=`eval echo $NodeNameQ`
RM="rm -rf"
MV="mv -f"

#Get the region name to avoid collisions
IRO=`wlookup InterRegion`
IRONAME=`idlattr -t -g $IRO name string`
IRONAME=`eval echo $IRONAME`

REMOVEFILES="FALSE"
MYUSAGE="FALSE"

if [ "$INTERP" != "w32-ix86" ];then
	LOG_FILE=/tmp/RCTGTM-R.log  
else
	LOG_FILE=$DBDIR/tmp/RCTGTM-R.log
fi

echo "Start" | tee $LOG_FILE

# parse command line

for i in "$@"; do
   case "$i" in 
      -rmfiles|-RMFILES)
         REMOVEFILES="TRUE"
      ;;
      -usage|-USAGE)
         MYUSAGE="TRUE"

      ;;
   esac
done

if [ "$MYUSAGE" = "TRUE" ]; then
   echo "RCTGTM-R.sh [-rmfiles] [-usage]" | tee -a $LOG_FILE
   echo "-usage: print this message" | tee -a $LOG_FILE
   echo "-rmfiles: remove files" | tee -a $LOG_FILE
   echo "done" | tee -a $LOG_FILE
   exit 0
fi

if [ "$INTERP" = "w32-ix86" ]; then
     
   WIN_DIR=`echo $windir | tr '\\\' '/'`

   if [ ! -f $DBDIR/.installed/RC_TGT_M.CFG ] ; then
	   echo "Cannot find the product installation directory."
	   echo "Uninstall failed!!"
	   exit 0
   fi

   RC_TGT_DIR=`cat $DBDIR/.installed/RC_TGT_M.CFG | tr '\\\' '/'`

   remove_misc

   update_ProductInfo "RC_TGT_M" "$NodeNameQ"
   
   remove_TagFiles 
   
   # remove_files will need to be filled in with the specific files that
   # apply to your application. You can get these files from the CFG files
   # of the application image. 
   
   if [ $REMOVEFILES = "TRUE" ]; then
      remove_files
   fi    
fi

if [ $DISP -eq 1 ];then
   remove_ProductInfo "RC_TGT_M"
fi

echo "done" | tee -a $LOG_FILE
exit 0
